import { __decorate, __extends, __metadata } from "tslib";
import { Component, Prop } from 'vue-property-decorator';
import BaseComponent from '../BaseComponent';
import { getStyles } from './Breadcrumb.styles';
import { classNamesFunction } from '@uifabric-vue/utilities';
import { Link } from '../Link';
import { Icon } from '../Icon';
var getClassNames = classNamesFunction();
var BreadcrumbBase = /** @class */ (function (_super) {
    __extends(BreadcrumbBase, _super);
    function BreadcrumbBase() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(BreadcrumbBase.prototype, "classNames", {
        get: function () {
            var _a = this, className = _a.className, theme = _a.theme;
            return getClassNames(getStyles, {
                theme: theme,
                className: className,
            });
        },
        enumerable: false,
        configurable: true
    });
    BreadcrumbBase.prototype.onBreadcrumbClicked = function (event, item) {
        if (item.onClick) {
            item.onClick(event, item);
        }
    };
    BreadcrumbBase.prototype.render = function (h) {
        var _this = this;
        var _a = this, classNames = _a.classNames, items = _a.items;
        return (<div class={classNames.root} role="navigation">
        <ol class={classNames.list}>
          {items.map(function (item, index) { return (<li key={index} class={classNames.listItem}>
              {(item.onClick || item.href)
            ? (<Link class={classNames.itemLink} href={item.href} onClick={function (ev) { return _this.onBreadcrumbClicked(ev, item); }}>
                    {item.text}
                  </Link>)
            : (<span class={classNames.item} onClick={function (ev) { return _this.onBreadcrumbClicked(ev, item); }}>
                    {item.text}
                  </span>)}

              {(index !== (items.length - 1)) && (<Icon key={"icon-" + index} class={classNames.chevron} icon-name="ChevronRight"/>)}
            </li>); })}
        </ol>
      </div>);
    };
    __decorate([
        Prop({ type: Array, required: true }),
        __metadata("design:type", Array)
    ], BreadcrumbBase.prototype, "items", void 0);
    BreadcrumbBase = __decorate([
        Component
    ], BreadcrumbBase);
    return BreadcrumbBase;
}(BaseComponent));
export { BreadcrumbBase };
//# sourceMappingURL=Breadcrumb.base.jsx.map