import { __decorate, __extends, __metadata } from "tslib";
import { Component, Prop } from 'vue-property-decorator';
import BaseComponent from '../BaseComponent';
import Icon from '../Icon/Icon';
import { classNamesFunction } from '@uifabric-vue/utilities';
var getClassNames = classNamesFunction();
var ContextualMenuItem = /** @class */ (function (_super) {
    __extends(ContextualMenuItem, _super);
    function ContextualMenuItem() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.openSubMenu = function () {
            var _a = _this, item = _a.item, openSubMenu = _a.openSubMenu;
            // if (getSubmenuTarget) {
            //   const submenuTarget = getSubmenuTarget()
            //   // if (hasSubmenu(item) && openSubMenu && submenuTarget) {
            //   //   openSubMenu(item, submenuTarget)
            //   // }
            // }
        };
        return _this;
    }
    Object.defineProperty(ContextualMenuItem.prototype, "classNames", {
        get: function () {
            return getClassNames(this.styles, {
                theme: this.theme,
            });
        },
        enumerable: false,
        configurable: true
    });
    ContextualMenuItem.prototype.render = function () {
        var _a = this, item = _a.item, classNames = _a.classNames;
        console.log(classNames);
        return (<button class={classNames.root}>
        <div class={item.split ? classNames.linkContentMenu : classNames.linkContent}>
          {this.renderCheckMarkIcon(this)}
          {this.renderItemIcon(this)}
          {this.renderItemName(this)}
          {this.renderSecondaryText(this)}
          {this.renderSubMenuIcon(this)}
        </div>
      </button>);
    };
    ContextualMenuItem.prototype.dismissSubMenu = function () {
        // const { item, dismissSubMenu } = this
        // if (hasSubmenu(item) && dismissSubMenu) {
        //   dismissSubMenu()
        // }
    };
    ;
    ContextualMenuItem.prototype.dismissMenu = function (dismissAll) {
        // const { dismissMenu } = this.props
        // if (dismissMenu) {
        //   dismissMenu(undefined /* ev */, dismissAll)
        // }
    };
    ;
    ContextualMenuItem.prototype.renderItemIcon = function (props) {
        var item = props.item, hasIcons = props.hasIcons, classNames = props.classNames;
        var iconProps = item.iconProps;
        if (!hasIcons) {
            return null;
        }
        if (item.onRenderIcon) {
            return item.onRenderIcon(props);
        }
        return <Icon {...iconProps} class={classNames.icon}/>;
    };
    ContextualMenuItem.prototype.renderCheckMarkIcon = function (_a) {
        var onCheckmarkClick = _a.onCheckmarkClick, item = _a.item, classNames = _a.classNames;
        var isItemChecked = false; // getIsChecked(item)
        if (onCheckmarkClick) {
            // Ensures that the item is passed as the first argument to the checkmark click callback.
            var onClick = function (e) { return onCheckmarkClick(item, e); };
            return (<Icon icon-name={item.canCheck !== false && isItemChecked ? 'CheckMark' : ''} class-name={classNames.checkmarkIcon} on-click={onClick}/>);
        }
        return null;
    };
    ContextualMenuItem.prototype.renderItemName = function (_a) {
        var item = _a.item, classNames = _a.classNames;
        // tslint:disable:deprecation
        if (item.text || item.name) {
            return <span class={classNames.label}>{item.text || item.name}</span>;
        }
        // tslint:enable:deprecation
        return null;
    };
    ContextualMenuItem.prototype.renderSecondaryText = function (_a) {
        var item = _a.item, classNames = _a.classNames;
        if (item.secondaryText) {
            return <span class={classNames.secondaryText}>{item.secondaryText}</span>;
        }
        return null;
    };
    ContextualMenuItem.prototype.renderSubMenuIcon = function (_a) {
        var item = _a.item, classNames = _a.classNames, theme = _a.theme;
        // if (hasSubmenu(item)) {
        //   return <Icon iconName={getRTL(theme) ? 'ChevronLeft' : 'ChevronRight'} {...item.submenuIconProps} class={classNames.subMenuIcon} />
        // }
        return null;
    };
    __decorate([
        Prop({ type: Object, default: function () { } }),
        __metadata("design:type", Object)
    ], ContextualMenuItem.prototype, "item", void 0);
    ContextualMenuItem = __decorate([
        Component({
            components: {},
        })
    ], ContextualMenuItem);
    return ContextualMenuItem;
}(BaseComponent));
export default ContextualMenuItem;
//# sourceMappingURL=ContextualMenuItem.base.jsx.map