import { ref } from '@vue/composition-api';
import { getId } from '@uifabric-vue/utilities';
export function useId(prefix, providedId) {
    // getId should only be called once since it updates the global constant for the next ID value.
    // (While an extra update isn't likely to cause problems in practice, it's better to avoid it.)
    var _ref = ref(providedId);
    if (!_ref.value) {
        _ref.value = getId(prefix);
    }
    return _ref.value;
}
//# sourceMappingURL=useId.js.map